// 15-12-2013
// see DS1307 read function is not working.htm
// http://www.edaboard.com/thread305029.html
#include <delays.h>
#include <i2c.h>
#include <stdlib.h>

extern unsigned char sec, min, hr, week_day, day, mn, year; 
// used variables must be initialised in BCD format, before calling this.
// example for 31/12/2013 le 06 23H59M00S  :
// sec=0x00;min=0x59;hr=0x23;week_day=6; day=0x31;mn=0x12;year=0x13;

// hardware 
 
void readDS1307()
    {   
	StartI2C1();
	WriteI2C1(0xD0);
	WriteI2C1(0x00);
	RestartI2C1();
	WriteI2C1(0xD1); //<--- corrected here
	sec = ReadI2C1();
	AckI2C1();
	min = ReadI2C1();
   	AckI2C1();
	hr = ReadI2C1();
 	AckI2C1();
	week_day = ReadI2C1();
 	AckI2C1();
	day = ReadI2C1();
 	AckI2C1();
	mn = ReadI2C1();
 	AckI2C1();
	year = ReadI2C1();
	NotAckI2C1();
	StopI2C1();

}

void writeDS1307()
 {
     StartI2C1();	
	WriteI2C1(0xD0);	
	WriteI2C1(0x00);	
	WriteI2C1(sec);// sec
	WriteI2C1(min);//minutes	
	WriteI2C1(hr);// hours	
	WriteI2C1(week_day);//week_day	
	WriteI2C1(day);//date	
    WriteI2C1(mn);//month	
	WriteI2C1(year);//year
	WriteI2C1(0x10);   // REG 7 - Enable squarewave output pin1hz 
	StopI2C1();
}


// -------------------- Formats date and time
void Transform_Time_BCD_To_Binary(char s, char m, char h, char wd, char d, char mo, char y)
{
sec = ((s & 0x70) >> 4)*10 + (s & 0x0F);
min = ((m & 0x70) >> 4)*10 + (m & 0x0F);
hr =  ((h  & 0x30) >> 4)*10 + (h & 0x0F);
week_day =(wd & 0x07);
day = ((d  & 0x30) >> 4)*10 + (d  & 0x0F);
mn =  ((mo   & 0x70) >> 4)*10 + (mo   & 0x0F);
year =((y & 0xF0) >> 4)*10 + (y & 0x0F);
}



